Codeforces Round 923 (Div. 3)

2024-02-07 23:36
文章标签 codeforces round div 923

本文主要是介绍Codeforces Round 923 (Div. 3),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

在这里插入图片描述

Codeforces Round 923 (Div. 3)

Codeforces Round 923 (Div. 3)

A. Make it White

题意:略
思路:找最小和最大的‘B’下标即可
AC code:

void solve() {cin >>n;string s; cin>> s;int mn = INF, mx = 0;for (int i = 0; i < n; i ++) {if (s[i] == 'B') {mn = min(mn, i);mx = max(mx, i);}}cout << mx - mn + 1 << endl;
}

B. Following the String

题意:略

思路:map记录26个字母的出现次数,0即是用新的字母

AC code:

void solve() {cin >> n;for (int i = 1; i <= n; i ++) cin >> a[i];map<char, int> mp;string s = "";for (int i = 1; i <= n; i ++) {for (char c = 'a'; c <= 'z'; c ++) {if (mp[c] == a[i]) {s += c;mp[c] ++;break;}}} cout << s << endl;
}

C. Choose the Different Ones!

题意:给出n个a数组元素和m个b数组元素,是否可以分别从a和b数组中取k/2个元素来组成1到k的每个元素
思路:用map分别记录ab数组元素,然后枚举1到k的元素,若有未出现的直接返回NO,然后记录ab数组的交集元素,最后检查仅存在于其中一个集合的元素是否大于k/2,若不存在则YES
AC code:

void solve() {cin >> n >> m >> k;map<int, int> ma, mb;for (int i = 1; i <= n; i ++) {int x; cin >> x;if (x <= k && x >= 1) ma[x] ++;}for (int i = 1; i <= m; i ++) {int x; cin >> x;if (x <= k && x >= 1) mb[x] ++;}int ca = ma.size(), cb = mb.size();int cnt = 0;for (int i = 1; i <= k; i ++) {if (!ma[i] && !mb[i]) {cout << "NO" << endl;return;}if (ma[i] && mb[i]) cnt ++;}if (ca - cnt > k / 2 || cb - cnt > k / 2) {cout << "NO" << endl;return;}cout << "YES" << endl;
}

D. Find the Different Ones!

题意:查询任意区间元素是否存在两个不同的元素
思路:从后往前记录最近的一个不同元素的下标,依次向前迭代
AC code:

void solve() {cin >> n;for (int i = 1; i <= n; i ++) cin >> a[i];nex[n] = -1;for (int i = n - 1; i >= 1; i --) {if (a[i] != a[i + 1]) nex[i] = i + 1;else nex[i] = nex[i + 1];}cin >> q;while (q --) {int l, r; cin >> l >> r;if (nex[l] != -1 && nex[l] <= r) {cout << l << " " << nex[l] << endl;} else {cout << "-1 -1" << endl;}}
}

E. Klever Permutation

题意:将1到n的数排列组合,使得每组相邻的k个元素的和相差不超过1
思路:

可以发现,每组向前迭代的过程都是先去掉一个头元素,再添一个尾元素;

那么只要去掉的和新的元素差不超过1即可,而两元素下标差为k;

所以我们可以枚举答案序列的前k个起始元素,每个元素以下标+k的方式迭代到最后;

这样可以满足答案序列每组删除和新增的元素差为1,但是不能保证每一组的和都是相差小于1;

所以可以从小到大一组,从大到小一组,通过一个标记点可以实现;
AC code:

void solve() {cin >> n >> k;vector<int> ans(n + 10, 0);int st = 1;bool flag = true;for (int i = 1; i <= k; i ++) {int x = i;if (flag) {while (x <= n) {ans[x] = st;st ++;x += k;}flag = false;} else {while (x <= n) {st ++;x += k;}int now;if (x > n) x -= k, now = st - 1;x = i;while (x <= n) {ans[x] = now;now --;x += k;}flag = true;}}for (int i = 1; i <= n; i ++) cout << ans[i] << " ";cout << endl;
}

F待补。。。。。。

这篇关于Codeforces Round 923 (Div. 3)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/689262

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There